var defaultPlugins = [
	{
		name: 'Save To Disk',
		key: 'save',
		dataType: 'image',
		editorDefault: true,
		onclick: function (scope) {
			String.prototype.twoDigits = function () { return this.replace(/^(.)$/, '0$1') };
			var x = scope.image_blob();
			var url = URL.createObjectURL(x);
			var filename;
			filename = scope.page_title || scope.page_url;
			filename = filename.replace(/[%&\(\)\\\/\:\*\?\"\<\>\|\/\]]/g, ' ');
			filename += '.png';
			var evt = document.createEvent("MouseEvents"); evt.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, true, false, false, 0, null);
			var a = $('<a></a>').appendTo(document.body);
			a.attr({ 'href': url, 'download': filename })[0].dispatchEvent(evt);
		}
	},
	{
		name: 'Open Screenshot',
		key: 'openscreenshot',
		dataType: 'image',
		editorDefault: true,
		url: '%s'
	},
	{
		name: 'Copy',
		key: 'copy',
		dataType: 'image',
		editorDefault: true,
		onclick: function (scope) {
			var image = scope.image_base64()
			mod = $('<div style=z-index:100000;position:fixed;width:100%;top:5%><center><span style="display:inline-block;background-color:white;padding:10px;border:1px solid black"><h2>Right click the image and choose "Copy Image"</h2><img style="max-width:80%;max-height:80%"></span></center></div>');
			$("img", mod).attr("src", 'data:image/png;base64,' + image);
			mod.appendTo(document.body);
			window.setTimeout(function () {
				$(document).one("click", function () {
					mod.remove();
				});
			}, 0);
		}
	},
];